<!DOCTYPE html>
<html lang='en'>
	<head>
    	<base href="<?php echo plugins_url() . '/wp-game/games/Puzzle/Hextris/' ?>">
		<title>Hextris</title>
		<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=0, minimal-ui"/>
		<meta property="og:url" content="http://hextris.github.io/hextris/" />
		<meta property="og:site_name" content="Hextris" />
		<meta property="og:title" content="Hextris" />
		<meta property="og:description" content="An addictive puzzle game inspired by Tetris." />
		<meta property="og:type" content="website" />
		<meta property="og:author" content="https://www.facebook.com/hextris" />
		<meta property="og:image" content="http://hextris.github.io/hextris/images/facebook-opengraph.png" />
		<meta property="og:image:width" content="1200" />
		<meta property="og:image:height" content="630" />
		<meta property="twitter:card" content="summary" />
		<meta property="twitter:site" content="@hextris" />
		<meta property="twitter:site:id" content="2742209678" />
		<meta property="twitter:creator" content="@hextris" />
		<meta property="twitter:creator:id" content="2742209678" />
		<meta property="twitter:domain" content="http://hextris.github.io" />
		<meta property="twitter:title" content="Hextris" />
		<meta property="twitter:description" content="An addictive puzzle game inspired by Tetris." />
		<meta property="twitter:image:src" content="http://hextris.github.io/hextris/images/twitter-opengraph.png" />
		<meta property="twitter:image:width" content="512" />
		<meta property="twitter:image:height" content="512" />
        <meta property="twitter:app:id:iphone" content="id903769553">
        <meta property="twitter:app:id:ipad" content="id903769553">
        <meta property="twitter:app:id:googleplay" content="com.hextris.hextris">
        <meta property="twitter:app:country" content="us">
        <meta property="twitter:app:url:iphone" content="itunes.apple.com/us/app/id903769553?mt=8">
        <meta property="twitter:app:url:ipad" content="itunes.apple.com/us/app/id903769553?mt=8">
        <meta property="twitter:app:url:googleplay" content="https://play.google.com/store/apps/details?id=com.hextris.hextris">
		<link rel="icon" type="image/png" href="favicon.ico">
		<link rel="stylesheet" type="text/css" href="style/style.css">
		<link rel="stylesheet" href="style/fa/css/font-awesome.min.css">
		<script type = 'text/javascript' src="vendor/hammer.min.js"></script>
		<script type = 'text/javascript' src="vendor/jsonfn.min.js"></script>
		<script type = 'text/javascript' src="vendor/keypress.min.js"></script>
		<script type = 'text/javascript' src="vendor/jquery.js"></script>
		<script type = 'text/javascript' src="js_v9/save-state.js"></script>
		<script type = 'text/javascript' src="js_v9/view.js"></script>
		<script type = 'text/javascript' src="js_v9/wavegen.js"></script>
		<script type = 'text/javascript' src="js_v9/math.js"></script>
		<script type = 'text/javascript' src="js_v9/Block.js"></script>
		<script type = 'text/javascript' src="js_v9/Hex.js"></script>
		<script type = 'text/javascript' src="js_v9/Text.js"></script>
		<script type = 'text/javascript' src="js_v9/comboTimer.js"></script>
		<script type = 'text/javascript' src="js_v9/checking.js"></script>
		<script type = 'text/javascript' src='js_v9/update.js'></script>
		<script type = 'text/javascript' src='js_v9/render.js'></script>
		<script type = 'text/javascript' src="js_v9/input.js"></script>
		<script type = 'text/javascript' src="js_v9/main.js"></script>
		<script type = 'text/javascript' src="js_v9/initialization.js"></script>
		<script type = 'text/javascript' charset = 'utf-8' src = 'cordova.js'></script>
	</head>
	<body>
		<div id="fb-root"></div>
		<script>(function(d, s, id) {
			var js, fjs = d.getElementsByTagName(s)[0];
			if (d.getElementById(id)) return;
			js = d.createElement(s); js.id = id;
			js.src = "http://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v2.0";
			fjs.parentNode.insertBefore(js, fjs);
			}(document, 'script', 'facebook-jssdk'));
		</script>
		<canvas id="canvas"></canvas>
		<div id='devtools' style='z-index:3;display:none;position:absolute;left:50%;width:400px;height:400px;top:50%;margin-top:-200px;margin-left:-200px;'>
			<h2 id = 'clickToExit' style = 'background-color:#fff;color:#000'>Click to exit</h2>
			<textarea id ='devtoolsText' style = 'height:300px;width:400px;'></textarea>
		</div>
		<div class="faded overlay"></div>
		<div id="attributions">Started by <a href="http://github.com/teamsnowman" target="_blank">@teamsnowman</a> at <a href= 'http://www.hackexeter.com/' target="_blank">HackExeter</a><br>
			Finished by <a href="http://github.com/meadowstream" target="_blank">Logan Engstrom</a> & <a href='http://github.com/garrettdreyfus' target="_blank">Garrett Finucane</a> on <a href = 'http://github.com/hextris/hextris' target="_blank">GitHub</a><br>
			<a href = 'https://itunes.apple.com/us/app/id903769553?mt=8'><b>iOS</b></a> <b>&</b> <a href ='https://play.google.com/store/apps/details?id=com.hextris.hextris'><b>Android</b></a> apps + <a href ='http://hextris.github.io/presskit/info.html'>press kit</a> @ <a href='http://hextris.github.io/'>http://hextris.github.io/</a>
		</div>
		<div id='startBtn' style='position:absolute;left:40%;top:38%;height:25%;width:25%;z-index:99999999;cursor:pointer;'></div>
		<div id="helpScreen" class = 'unselectable'>
			<h1 class = 'instructions_body'>Instructions</h1>
			<p class = 'instructions_body' id = 'inst_main_body'></p>
		</div>
		<div id="openSideBar" class = 'helpText'><i class="fa fa-info-circle fa-lg"></i> <i class="fa fa-arrow-left"><b>  Help</b></i></div>
		<div class="faded overlay"></div>
		<div id = 'pauseBtn'><div id = 'pauseBtnInner'><i class="fa fa-pause fa-2x"></i></div></div>
		<div id = 'restartBtn'><div id = 'restartBtnInner'><i class="fa fa-refresh fa-2x"></i></div></div>
		<div id="bottombar">
                        <div style="bottom:4px; padding-right:4px;" class="fb-like" data-href="http://hextris.github.io/hextris" data-width="20" data-layout="button_count" data-action="like" data-show-faces="false" data-share="true"></div>
			<a onClick="tweetblock=true" href="https://twitter.com/intent/tweet?hashtags=hextris&original_referer=http%3A%2F%2F0.0.0.0%3A8080%2F&text=Play%20Hextris!%20-&tw_p=tweetbutton&url=http%3A%2F%2Fhextris.github.io%2F" class="twitter-share-button" data-url="http://hextris.github.io/" data-text="Play Hextris! -" data-hashtags="hextris">Tweet</a>
                        <a href="https://twitter.com/hextris" class="twitter-follow-button" data-show-count="false" data-show-screen-name="false">Follow @hextris</a>
                        <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
			<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
			<iframe id = 'ghl' src="http://ghbtns.com/github-btn.html?user=Hextris&repo=Hextris&type=watch&count=true" allowtransparency="true" frameborder="0" scrolling="0" width="90" height="20" onload='showbottombar()'></iframe>
		</div>
        <script> (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){ (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o), m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m) })(window,document,'script','//www.google-analytics.com/analytics.js','ga'); ga('create', 'UA-51272720-2', 'auto'); ga('send', 'pageview'); </script>
    <?php wp_footer(); ?>
    </body>
</html>
